/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import BN from "bn.js";
import { Contract, ContractOptions } from "web3-eth-contract";
import { EventLog } from "web3-core";
import { EventEmitter } from "events";
import { ContractEvent, Callback, TransactionObject, BlockType } from "./types";

interface EventOptions {
  filter?: object;
  fromBlock?: BlockType;
  topics?: string[];
}

export class ProxyAdminData extends Contract {
  constructor(
    jsonInterface: any[],
    address?: string,
    options?: ContractOptions
  );
  clone(): ProxyAdminData;
  methods: {
    isOwner(): TransactionObject<boolean>;

    owner(): TransactionObject<string>;

    renounceOwnership(): TransactionObject<void>;

    transferOwnership(newOwner: string): TransactionObject<void>;

    getProxyImplementation(proxy: string): TransactionObject<string>;

    getProxyAdmin(proxy: string): TransactionObject<string>;

    changeProxyAdmin(proxy: string, newAdmin: string): TransactionObject<void>;

    upgrade(proxy: string, implementation: string): TransactionObject<void>;

    upgradeAndCall(
      proxy: string,
      implementation: string,
      data: string | number[]
    ): TransactionObject<void>;
  };
  events: {
    OwnershipTransferred: ContractEvent<{
      previousOwner: string;
      newOwner: string;
      0: string;
      1: string;
    }>;
    allEvents: (
      options?: EventOptions,
      cb?: Callback<EventLog>
    ) => EventEmitter;
  };
}
